# coding: utf-8

"""
    Endpoint Test Results API

    Retrieve results for scheduled and dynamic tests on endpoint agents.

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class TracerouteHop(BaseModel):
    """
    TracerouteHop
    """ # noqa: E501
    hop: Optional[StrictInt] = Field(default=None, description="The hop index.")
    ip_address: Optional[StrictStr] = Field(default=None, description="IP address of the hop.", alias="ipAddress")
    prefix: Optional[StrictStr] = Field(default=None, description="Prefix of IP address shown in CIDR.")
    asn: Optional[StrictInt] = Field(default=None, description="Unique number assigned to an organization (also referred to as service provider).")
    delay: Optional[StrictInt] = Field(default=None, description="Hop delay")
    mpls: Optional[List[StrictStr]] = Field(default=None, description="Hop Multiprotocol Label Switching.")
    name: Optional[StrictStr] = Field(default=None, description="The hop name.")
    __properties: ClassVar[List[str]] = ["hop", "ipAddress", "prefix", "asn", "delay", "mpls", "name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="allow",
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return self.model_dump_json(by_alias=True, exclude_unset=True, exclude_none=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TracerouteHop from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "hop",
            "ip_address",
            "prefix",
            "asn",
            "delay",
            "mpls",
            "name",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TracerouteHop from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "hop": obj.get("hop"),
            "ipAddress": obj.get("ipAddress"),
            "prefix": obj.get("prefix"),
            "asn": obj.get("asn"),
            "delay": obj.get("delay"),
            "mpls": obj.get("mpls"),
            "name": obj.get("name")
        })
        return _obj


